if select(2,UnitClass("player")) ~= "MONK" then return end
local Transcendence = Transcendence
--------------------------------------------------------------------------------------
local AceLocale = LibStub("AceLocale-3.0")
local L = AceLocale:GetLocale( "Transcendence")
--------------------------------------------------------------------------------------

local TRANSCENDENCE_TEXTURE = "Interface\\Icons\\monk_ability_transcendence"
local TRANSCENDENCE_TRANSFER_TEXTURE = "Interface\\Icons\\Spell_Shaman_SpectralTransformation"
local statusbar_texture="Interface\\TargetingFrame\\UI-StatusBar"
local font = "Fonts\\msyhbd.ttc"		--Microsoft Yahei Fonts. $100 per character!
local TRANSFER_DISTANCE = 40
local TRANSFER_DISTANCE_SQUARED = TRANSFER_DISTANCE * TRANSFER_DISTANCE
local GetCVar = GetCVar
local UnitPosition = UnitPosition
local GetSpellInfo = GetSpellInfo
local select = select
local min = min
local max = max
local string_match = string.match
local string_format = string.format
local math_floor = math.floor
local math_sqrt = math.sqrt
local math_acos = math.acos
local math_sin = math.sin
local math_cos = math.cos
local math_atan2 = math.atan2
local GetTime = GetTime
local frame = Transcendence.frame
local UnitGUID = UnitGUID
local GetSpellBaseCooldown = GetSpellBaseCooldown
--------------------------------------------------------------------------------------
local golden_section = (math_sqrt(5)-1)/2
local two_pi = math.pi * 2
local Trd_frame = CreateFrame("Frame", nil , UIParent) 


local function save_Trd_frame_coord()
	Trd_frame:StopMovingOrSizing()
	Transcendence.db.profile.pos_left = Trd_frame:GetLeft()
	Transcendence.db.profile.pos_top = Trd_frame:GetTop()
end

function Transcendence:lock()
	if not Transcendence.db.profile.lock then
		Trd_frame:SetMovable(true)
		Trd_frame:EnableMouse(true)
		Trd_frame:SetScript("OnMouseDown", function() Trd_frame:StartMoving() end)
		Trd_frame:SetScript("OnMouseUp", save_Trd_frame_coord)
		Trd_frame:SetScript("OnDragStop", function() Trd_frame:StopMovingOrSizing() end)
	else
		Trd_frame:SetMovable(false)
		Trd_frame:EnableMouse(false)
		Trd_frame:SetScript("OnMouseDown", function() end)
		Trd_frame:SetScript("OnMouseUp", function() end)
		Trd_frame:SetScript("OnDragStop", function() end)
	end
end

local icon_texture
local direction
local distance
local cd
local icon_bg

function Transcendence:Init()
	Trd_frame:SetFrameStrata("MEDIUM")
	Trd_frame:SetClampedToScreen(true)
	Trd_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",Transcendence.db.profile.pos_left,Transcendence.db.profile.pos_top);
	Trd_frame:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 

	Transcendence:lock()
	icon_bg = Trd_frame:CreateTexture(nil, "BACKGROUND")
	icon_bg:SetAllPoints(Trd_frame)
	icon_bg:SetTexture(statusbar_texture)
	icon_bg:SetVertexColor(0,0,0,1)
	icon_texture = Trd_frame:CreateTexture(nil, "BORDER")
	icon_texture:SetPoint("CENTER", Trd_frame, "CENTER",0,0)

--	icon_texture:SetAllPoints(Trd_frame)
	icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
	icon_texture:SetTexCoord(0.1,0.9,0.1,0.9)
--	icon_texture:SetVertexColor(1,1,1,golden_section)
--	icon_texture:SetSize(Transcendence.db.profile.iconSize-4,Transcendence.db.profile.iconSize-4) 
	direction = Trd_frame:CreateTexture(nil, "OVERLAY") 
	direction:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 
--	direction:SetVertexColor(0,0,0,0)
	direction:SetTexture("Interface\\AddOns\\Transcendence\\texture\\Arrows32-32x32.tga") 
	direction:SetBlendMode("ADD") 
	direction:SetPoint("CENTER")

	distance = Trd_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	distance:SetFont(font, Transcendence.db.profile.fontSize, "OUTLINE")
	distance:SetPoint("CENTER", Trd_frame, "CENTER",0, 0)
	distance:SetTextColor(0,1,0,1)
	
	cd = Trd_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	cd:SetPoint("BOTTOM", Trd_frame, "BOTTOM",0,5)
	cd:SetTextColor(1,1,1,1)
	
	Transcendence:UpdateDB()
end
local spirit_location=
{
	x = nil,
	y = nil,
	flr = nil,
	map =nil
}
function Transcendence:COMBAT_LOG_EVENT_UNFILTERED(...)
	if select(5, ...) == UnitGUID("player") then
		if(select(3, ...)=="SPELL_AURA_REMOVED" and select(13, ...) == 101643)
		then
			spirit_location.x,spirit_location.y,spirit_location.flr,spirit_location.map = nil,nil,nil,nil
		end
	end
end

function Transcendence:ZONE_CHANGED_NEW_AREA()
	spirit_location.x,spirit_location.y,spirit_location.flr,spirit_location.map = nil,nil,nil,nil
end
local lineID = nil

local slt_x,slt_y,slt_flr,slt_map

function Transcendence:UNIT_SPELLCAST_SUCCEEDED(...)
	if select(2,...)=="player" then
		local spellId = select(6,...)
		if spellId==101643 then
			spirit_location.x,spirit_location.y,spirit_location.flr,spirit_location.map = UnitPosition("player")
		elseif spellId == 119996 then
			if lineID and select(4,...) == lineID then
				spirit_location.x,spirit_location.y,spirit_location.flr,spirit_location.map=slt_x,slt_y,slt_flr,slt_map
			else
				spirit_location.x,spirit_location.y,spirit_location.flr,spirit_location.map=UnitPosition("player")
			end
			lineID = nil
			slt_x,slt_y,slt_flr,slt_map = nil,nil,nil,nil
		end
	end
end

function Transcendence:UNIT_SPELLCAST_SENT(...)
	local _,unit,spell,lid = ...
	if unit=="player" then
		if spell=="Transcendence: Transfer" then
			lineID = lid
			slt_x,slt_y,slt_flr,slt_map = UnitPosition("player")
		end
	end
end

function Transcendence:refresh_font_size()
	distance:SetFont(font, Transcendence.db.profile.fontSize, "OUTLINE")
end

function Transcendence:refresh_cd_font_size()
	cd:SetFont(font, Transcendence.db.profile.cdFontSize, "OUTLINE")
end

function Transcendence:refresh_icon_size()
	Trd_frame:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize) 
	icon_texture:SetSize(Transcendence.db.profile.iconSize-4,Transcendence.db.profile.iconSize-4) 
	direction:SetSize(Transcendence.db.profile.iconSize,Transcendence.db.profile.iconSize)
	direction:SetVertexColor(Transcendence.db.profile.arrowColorr,Transcendence.db.profile.arrowColorg,Transcendence.db.profile.arrowColorb,Transcendence.db.profile.arrowColora)
end

function Transcendence:refresh_location()
	Trd_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",Transcendence.db.profile.pos_left,Transcendence.db.profile.pos_top);
end

local dis_fixed_precision_str
local cd_fixed_precision_str
function Transcendence:refresh_dis_fixed_precision()
	dis_fixed_precision_str = string_format("%%.%df",Transcendence.db.profile.disFixedPrecision)
end

function Transcendence:refresh_cd_fixed_precision()
	cd_fixed_precision_str = string_format("%%.%df",Transcendence.db.profile.cdFixedPrecision)
end

local update_timer =0 
local refresh_rate = .1
function Transcendence:refresh_TRANSFER_DISTANCE()
	TRANSFER_DISTANCE = 40 * Transcendence.db.profile.mapErrorFactor
	TRANSFER_DISTANCE_SQUARED = TRANSFER_DISTANCE * TRANSFER_DISTANCE
end

function Transcendence:refresh_rate_modified()
	update_timer = 0
	refresh_rate = Transcendence.db.profile.refreshRate
end

local enable_cd
function Transcendence:refresh_enable_cd()
	enable_cd = Transcendence.db.profile.enableCD
end

local function update_main()
	local x,y,flr,map = UnitPosition("player")
	if flr== spirit_location.flr and map == spirit_location .map
	then
		local dx = spirit_location.x - x
		local dy = spirit_location.y - y
		local distance_squared = dx *dx + dy  *dy 
		distance:SetText(string_format(dis_fixed_precision_str,math_sqrt(distance_squared)))
		if distance_squared == 0
		then
			if IsUsableSpell(119996)==true
			then
				icon_texture:SetTexture(TRANSCENDENCE_TRANSFER_TEXTURE)
				icon_texture:SetVertexColor(1,0.1,0.1,golden_section)
			else
				icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
				icon_texture:SetVertexColor(1,0.1,0.1,golden_section)
			end
			distance:SetTextColor(0,1,0,1)
			direction:Hide()
		else
			-- Thanks for Grid2 (StatusDirection) 's wonderful code and wonderful arrow tga!!
			local dir_tex = (math_floor( (math_atan2(dy,dx)-GetPlayerFacing()) / two_pi * 32 + 0.5) % 32)/32
			direction:SetTexCoord(.05, 0.95, dir_tex+0.0015625, dir_tex+0.028125)
			if IsUsableSpell(119996)==true
			then
				icon_texture:SetTexture(TRANSCENDENCE_TRANSFER_TEXTURE)
				icon_texture:SetVertexColor(1,0.1,0.1,golden_section)
				distance:SetTextColor(0,1,0,1)
				direction:Show()
			else
				if distance_squared < TRANSFER_DISTANCE_SQUARED
				then
					icon_texture:SetTexture(TRANSCENDENCE_TRANSFER_TEXTURE)
					icon_texture:SetVertexColor(0,.5,0.1,golden_section)
					distance:SetTextColor(0,1,0,1)
					direction:Show()
				else
					icon_texture:SetTexture(TRANSCENDENCE_TEXTURE)
					icon_texture:SetVertexColor(1,1,1,golden_section)
					direction:Show()
					if 6400< distance_squared
					then
						distance:SetTextColor(1,0,0,1)
					else
						distance:SetTextColor(1,1,0,1)
					end
				end
			end
		end
		if enable_cd and enable_cd == true then
			local start, duration = GetSpellCooldown(119996)
			local lasttm = start + GetSpellBaseCooldown(119996)/1000 - GetTime()
			if 1.5 < duration and 0<= lasttm  then
				cd:SetText(string_format(cd_fixed_precision_str,lasttm))
				if lasttm < 3 then
					cd:SetTextColor(1,0,0,1)
				else
					cd:SetTextColor(1,1,1,1)
				end
			else
				cd:SetText("")
			end
		else
			cd:SetText("")
		end
		Trd_frame:Show()
	else
		Trd_frame:Hide()
	end
end

local function on_update(this, elapsed)
	update_timer = update_timer + elapsed
	if refresh_rate <= update_timer then
		if spirit_location.x then
			update_main()
		else
			Trd_frame:Hide()
		end
		update_timer = 0
	end
end
frame:SetScript("OnUpdate", on_update)
